'use strict';
angular.module('aom.directives')
  .directive('aomCurrentPosition', function () {
    return {
      scope: {
        field: '='
      },

      templateUrl: 'App/Common/Directives/CurrentPosition/currentposition.html',
      
      controller: function ($scope, $ionicLoading, aomLocationSrv, aomComponentsSrv, aomJobSrv) {

        $scope.showCurrentLatAndLong = function (field) {

          $ionicLoading.show({
            template: 'Calculating gps location ...',
            delay: 100
          });

          aomLocationSrv.getAccurateCurrentLocation()
            .then(function () {
              $ionicLoading.hide();
              var lastLocale = aomLocationSrv.data.lastLocationForServer;
              field.Data = lastLocale.latitude + ',' + lastLocale.longitude;
              aomJobSrv.calc(field.Name);
            });

        };

        $scope.openMap = function (fieldData) {
          var coords = fieldData.split(',');
          aomComponentsSrv.launchNavigator(coords[0], coords[1]);
        };

      }
    };
  });