angular.module('aom.services')
  .factory('aomDeviceSrv', function ($q, aomFileSystemSrv, aomDatabaseSrv, aomJobsSrv, constants) {

    var device = {};

    device.data = {
      showUpgradePrompt: true
    };

    aomFileSystemSrv.createDirectory(constants.common.aomAdhocAttachmentsDirectory);

    device.clean = function () {
      return aomDatabaseSrv.deleteQuery({ Jobs: {} })
        .then(function () {
          aomJobsSrv.data.jobs.length = 0;
          aomJobsSrv.data.filteredJobs.length = 0;
          aomJobsSrv.data.bounds.length = 0;
          return aomDatabaseSrv.deleteQuery({ Templates: {} });
        })
        .then(function () {
          aomJobsSrv.data.templates.length = 0;
          aomJobsSrv.data.filteredTemplates.length = 0;
          return aomDatabaseSrv.deleteQuery({ Attachments: {} });
        })
        .then(function () {
          return aomDatabaseSrv.deleteQuery({ Recovery: {} });
        })
        .then(function () {
          return aomFileSystemSrv.createDirectory(constants.common.logoFolder);
        })
        .then(function () {
          return aomFileSystemSrv.createDirectory(constants.common.aomAttachmentsDirectory);
        })
        .then(function () {
          return aomFileSystemSrv.createDirectory(constants.common.aomAdhocAttachmentsDirectory);
        });
    };

    device.cleanLogo = function () {
      return aomFileSystemSrv.removeFolder(constants.common.logoFolder);
    };

    device.removeAdhocDocumentsAndRecreateDirectory = function () {
      return aomFileSystemSrv.removeFolder(constants.common.aomAdhocAttachmentsDirectory)
        .then(function () {
          return aomFileSystemSrv.createDirectory(constants.common.aomAdhocAttachmentsDirectory);
        });
    };

    device.isInPortrait = function () {
      return screen.orientation.angle === 0 || screen.orientation.angle === 180;
    };

    device.uuid = function () {
      return window.cordova ? window.device.uuid : 'browser';
    };

    device.model = function () {
      return window.cordova ? window.device.model : window.navigator.userAgent;
    };

    device.manufacturer = function () {
      // return 'TomTom'; // for debugging on serve
      return window.cordova ? window.device.manufacturer : window.navigator.vendor;
    };

    device.isTomTom = function () {
      return device.manufacturer().toLowerCase().indexOf('tomtom') !== -1
        || device.manufacturer().toLowerCase().indexOf('webfleet') !== -1;
    };

    return device;
  });
