angular.module('aom.services')
  .factory('aomMigrationSrv', function ($q, aomFileSystemSrv, aomComponentsSrv) {
    var migrationSrv = {};

    migrationSrv.init = function init() {
      let promises = [];
      if (ionic.Platform.isAndroid()) {
        const v3Files = ['client_db-journal', 'db_white_space-journal', 'client_db', 'db_white_space'];
        promises = v3Files.map(filename => aomFileSystemSrv.removeFile(cordova.file.externalRootDirectory, filename));
        promises.push(aomFileSystemSrv.removeDirectory(cordova.file.externalRootDirectory + 'Android/data/com.whitespacews.allonmobile/files/', 'Pictures'));
      } else if (ionic.Platform.isIOS()) {
        const v3Files = ['AOMDatabase.sqlite', 'Job.sqlite', 'Job.sqlite-shm', 'Job.sqlite-wal'];
        promises = v3Files.map(filename => aomFileSystemSrv.removeFile(cordova.file.documentsDirectory, filename));
        promises.push(aomFileSystemSrv.removeDirectory(cordova.file.documentsDirectory, 'SQLFiles'));
      }
      const v4Files = ['aom.db', 'customer.db'];
      promises.push(v4Files.map(filename => aomFileSystemSrv.removeFile(aomComponentsSrv.databasePath(), filename)));

      $q.all(promises);
    };

    return migrationSrv;
  });